diff --git a/raddb/mods-available/sql b/raddb/mods-available/sql
index 05e3e0b6fd6..57996aaaba3 100644
--- a/raddb/mods-available/sql
+++ b/raddb/mods-available/sql
@@ -229,6 +229,42 @@ sql {
 
 	# Table to keep radius client info
 	client_table = "nas"
+	#  Sets default values (not obtained from LDAP) for new client entries
+	#
+	template {
+#			login				= 'test'
+#			password			= 'test'
+#			proto	 			= tcp
+#			require_message_authenticator	= yes
+
+		# Uncomment to add a home_server with the same
+		# attributes as the client.
+#			coa_server {
+#				response_window = 2.0
+#			}
+	}
+
+	#
+	# Table to keep radius client info
+	#
+	client {
+		#  Client attribute mappings are in the format:
+		#      <client attribute> = <table field name>
+		#
+		#  The following attributes are required:
+		#    * ipaddr - Client IP Address.
+		#    * secret - RADIUS shared secret.
+		#
+		#  All other attributes usually supported in a client
+		#  definition are also supported here.
+		attribute {
+			ipaddr		= "nasname"
+			shortname	= "shortname"
+			nas_type	= "type"
+			secret		= "secret"
+			virtual_server	= "server"
+		}
+	}
 
 	#
 	# The group attribute specific to this instance of rlm_sql
diff --git a/src/modules/rlm_sql/rlm_sql.c b/src/modules/rlm_sql/rlm_sql.c
index 56df54be656..e38dfda6671 100644
--- a/src/modules/rlm_sql/rlm_sql.c
+++ b/src/modules/rlm_sql/rlm_sql.c
@@ -138,7 +138,7 @@ static sql_fall_through_t fall_through(VALUE_PAIR *vp)
 /*
  *	Yucky prototype.
  */
-static int generate_sql_clients(rlm_sql_t *inst);
+static int generate_sql_clients(rlm_sql_t *inst, CONF_SECTION *tmpl, CONF_SECTION *map);
 static size_t sql_escape_func(REQUEST *, char *out, size_t outlen, char const *in, void *arg);
 
 /*
@@ -269,12 +269,81 @@ static ssize_t sql_xlat(void *instance, REQUEST *request, char const *query, cha
 	return ret;
 }
 
-static int generate_sql_clients(rlm_sql_t *inst)
+/**
+ * Retrieve the position of 'field_name' when match with 'col_names[pos]'
+ */
+typedef struct rows_data_t {
+	rlm_sql_handle_t *handle;
+	int num_fields;
+	const char **col_names;
+} rows_data_t;
+
+static ssize_t get_pos_nasquery_indexof(rows_data_t *rd, const char *field_name) {
+	rlm_sql_handle_t *handle = rd->handle;
+	ssize_t pos = 0;
+
+	for (pos = 0; pos < rd->num_fields; pos++) {
+		if (!strcasecmp(rd->col_names[pos], field_name)) {
+			return pos;
+		}
+	}
+
+	ERROR("rlm_sql (%s): The field '%s' isn't not known for get_pos_nasquery_indexof()", handle->inst->name, field_name);
+
+	return -1;
+}
+
+/**
+ * Handle client value processing for client_map_section()
+ *
+ * @param  out  Character output
+ * @param  cp   Configuration pair
+ * @param  data The client data
+ * @return      Returns 0 on success, -1 on error.
+ */
+static int _get_client_value(char **out, CONF_PAIR const *cp, void *data)
+{
+	rows_data_t *rd = data;
+	const char *field_name = cf_pair_value(cp);
+	const char *field_value;
+	ssize_t pos;
+
+	rad_assert(field_name != NULL);
+	rad_assert(data != NULL);
+
+	*out = NULL;
+
+	/* get the 'field_value' position in ->row[]*/
+	pos = get_pos_nasquery_indexof(rd, field_name);
+	if (pos < 0) return -1;
+
+	field_value = rd->handle->row[pos];
+	if (!field_value) return -1;
+
+	if (*field_value != '\0') {
+		*out = talloc_strdup(NULL, field_value);
+		if (!*out) return -1;
+	}
+
+	return 0;
+}
+
+/*
+ * @param[in] inst rlm_sql configuration.
+ * @param[in] tmpl to use as the base for the new client.
+ * @param[in] map to load client attribute/SQL attribute mappings from.
+ * @return
+ *	- 0 on success.
+ *	- -1 on failure.
+ */
+static int generate_sql_clients(rlm_sql_t *inst, CONF_SECTION *tmpl, CONF_SECTION *map)
 {
 	rlm_sql_handle_t *handle;
 	rlm_sql_row_t row;
 	unsigned int i = 0;
-	RADCLIENT *c;
+	RADCLIENT *client;
+	int retval = -1;
+	rows_data_t rd;
 
 	DEBUG("rlm_sql (%s): Processing generate_sql_clients",
 	      inst->name);
@@ -282,13 +351,28 @@ static int generate_sql_clients(rlm_sql_t *inst)
 	DEBUG("rlm_sql (%s) in generate_sql_clients: query is %s",
 	      inst->name, inst->config->client_query);
 
-	handle = fr_connection_get(inst->pool);
+	rd.handle = handle = fr_connection_get(inst->pool);
 	if (!handle) return -1;
 
-	if (rlm_sql_select_query(inst, NULL, &handle, inst->config->client_query) != RLM_SQL_OK) return -1;
+	if (rlm_sql_select_query(inst, NULL, &handle, inst->config->client_query) != RLM_SQL_OK) {
+		goto finish;
+	}
+
+	rd.num_fields = (inst->module->sql_num_fields)(handle, inst->config);
+	if (rd.num_fields < 1) {
+		WARN("rlm_sql: There are no rows affected by query. has values?");
+		goto finish;
+	}
+
+	if ((inst->module->sql_fields)(&rd.col_names, handle, inst->config) != RLM_SQL_OK) {
+		ERROR("rlm_sql: Can't get columns names");
+		goto finish;
+	}
 
 	while ((rlm_sql_fetch_row(inst, NULL, &handle) == 0) && (row = handle->row)) {
-		char *server = NULL;
+		CONF_SECTION *cs;
+		const char *server = NULL;
+		const char *id = NULL;
 		i++;
 
 		/*
@@ -318,43 +402,70 @@ static int generate_sql_clients(rlm_sql_t *inst)
 			continue;
 		}
 
-		if (((inst->module->sql_num_fields)(handle, inst->config) > 5) && (row[5] != NULL) && *row[5]) {
-			server = row[5];
-		}
+		if (row[5] != NULL && *row[5]) server = row[5];
 
 		DEBUG("rlm_sql (%s): Adding client %s (%s) to %s clients list",
 		      inst->name,
 		      row[1], row[2], server ? server : "global");
 
-		/* FIXME: We should really pass a proper ctx */
-		c = client_afrom_query(NULL,
-				      row[1],	/* identifier */
-				      row[4],	/* secret */
-				      row[2],	/* shortname */
-				      row[3],	/* type */
-				      server,	/* server */
-				      false);	/* require message authenticator */
-		if (!c) {
-			continue;
+		/* client name */
+		id = cf_section_name2(cs);
+
+		/* allocate conf section */
+		cs = tmpl ? cf_section_dup(NULL, tmpl, "client", id, true) :
+					cf_section_alloc(NULL, "client", id);
+		if (!cs) {
+			ERROR("rlm_sql: failed to alloc client section while loading clients");
+			retval = -1;
+			goto finish;
+		}
+
+		if (client_map_section(cs, map, _get_client_value, &rd) < 0) {
+			DEBUG("rlm_sql: Problems with client_map_section()");
+			talloc_free(cs);
+			retval = -1;
+			goto finish;
 		}
 
-		if (!client_add(NULL, c)) {
-			WARN("Failed to add client, possible duplicate?");
+		client = client_afrom_cs(NULL, cs, false, false);
+		if (!client) {
+			DEBUG("rlm_sql: failed to allocate client");
+			talloc_free(cs);
+			retval = -1;
+			goto finish;
+		}
+
+		/*
+		* Client parents the CONF_SECTION which defined it.
+		*/
+		talloc_steal(client, cs);
 
-			client_free(c);
+		if (!client) {
 			continue;
 		}
 
-		DEBUG("rlm_sql (%s): Client \"%s\" (%s) added", c->longname, c->shortname,
+		if (!client_add(NULL, client)) {
+			WARN("rlm_sql: Failed to add client, possible duplicate?");
+			client_free(client);
+			continue;
+		}
+
+		DEBUG("rlm_sql (%s): Client \"%s\" (%s) added", client->longname, client->shortname,
 		      inst->name);
+
+		retval = 0;
 	}
 
+finish:
+
 	(inst->module->sql_finish_select_query)(handle, inst->config);
-	fr_connection_release(inst->pool, handle);
 
-	return 0;
-}
+	if (handle) {
+		fr_connection_release(inst->pool, handle);
+	}
 
+	return retval;
+}
 
 /*
  *	Translate the SQL queries.
@@ -997,8 +1108,24 @@ do { \
 	if (!inst->pool) return -1;
 
 	if (inst->config->do_clients) {
-		if (generate_sql_clients(inst) == -1){
-			ERROR("Failed to load clients from SQL");
+		CONF_SECTION *cs, *map, *tmpl;
+
+		cs = cf_section_sub_find(inst->cs, "client");
+		if (!cs) {
+			cf_log_err_cs(conf, "Told to load clients but no 'client' section found");
+			return -1;
+		}
+
+		map = cf_section_sub_find(cs, "attribute");
+		if (!map) {
+			cf_log_err_cs(cs, "Told to load clients but no 'attribute' section found");
+			return -1;
+		}
+
+		tmpl = cf_section_sub_find(cs, "template");
+
+		if (generate_sql_clients(inst, tmpl, map) < 0) {
+			cf_log_err_cs(cs, "Failed to load clients from SQL");
 			return -1;
 		}
 	}
